#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Res_Icon_Add=On.ico
#AutoIt3Wrapper_Res_Icon_Add=Off.ico
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

Global $inifile = @WindowsDir & "\NetCheck.ini"

If Not FileExists($inifile) Then _Initialise()
$TIP=IniRead($inifile,"Main","TestServer","8.8.8.8")
$TPort=IniRead($inifile,"Main","TestPort","53")
$TTime=IniRead($inifile,"Main","TimeOut","100")
$HotKey=IniRead($inifile,"Main","Hotkey","+!\")

HotKeySet($HotKey, "_Exit")

If $CmdLine[0] > 0 Then
	Select
		Case $CmdLine[1] = "logon"
			$logon = 1
		Case $CmdLine[1] = "startup"
			$logon = 0
		Case Else
	EndSelect
Else
	$logon = 0
EndIf


Opt('TCPTimeout', $TTime)
TCPStartup()

If $logon Then TraySetState()

While 1
	If (ProcessExists("explorer.exe") > 0) And (Not $logon) Then ExitLoop
	$socket = TCPConnect($TIP, $TPort)
	If $socket = -1 Then
		If $logon Then
			TraySetIcon(@ScriptName, -6)
			TraySetToolTip("Network disconnected!")
		Else
			ToolTip("Not Connected", 0, 0,"Network Status", 3, 5)
		EndIf
	Else
		TCPCloseSocket($socket)
		If $logon Then
			TraySetIcon(@ScriptName, -5)
			TraySetToolTip("Network connected")
		Else
			ToolTip("Connected", 0, 0,"Network Status", 1, 5)
		EndIf
	EndIf
	Sleep(5000)
WEnd

Func _Exit()
	TCPShutdown()
	Exit
EndFunc

Func _Initialise()
	IniWrite($inifile, "Main", "TestServer", "8.8.8.8")
	IniWrite($inifile, "Main", "TestPort", "53")
	IniWrite($inifile, "Main", "TTime", "100")
	IniWrite($inifile, "Main", "Hotkey", "+!\")
	$file = FileOpen($inifile, 1)
	FileWrite($file, @CRLF & "; Where: TestServer = IP address of a server to make a test connection to." & @CRLF & ";        TestPort   = Server port to make a test connection to." & @CRLF & ";        TimeOut    = Test connection timeout value in milliseconds.  Test will" & @CRLF & ";                     fail if it can't make a connection in this time." & @CRLF & ";        Hotkey     = Key sequence to terminate program." & @CRLF & ";                             + = Shift" & @CRLF & ";                             ! = Alt" & @CRLF & ";                             ^ = Control" & @CRLF & ";                             # = Windows")
	FileClose($file)
EndFunc
